
public final class Rasterize_Clip_Line
{
   public static void rasterize(final Model model,
                                final LineSegment ls,
                                final FrameBuffer.Viewport vp)
   {
      final int w = vp.getWidthVP();  // Needed for the clipping test.
      final int h = vp.getHeightVP();

      final int vIndex0 = ls.vIndexList.get(0);
      final int vIndex1 = ls.vIndexList.get(1);
      final Vertex v0 = model.vertexList.get(vIndex0);
      final Vertex v1 = model.vertexList.get(vIndex1);

      // Round each point's coordinates to the nearest logical pixel.
      final double x0 = Math.round(v0.x); // snap-to-pixel in pixel-plane
      final double y0 = Math.round(v0.y);
      final double x1 = Math.round(v1.x); // snap-to-pixel in pixel-plane
      final double y1 = Math.round(v1.y);

      double y = y0;
      for (int x = (int)x0; x <= (int)x1; x += 1, y += m)
      {
         // Translate pixel-plane coordinates to viewport coordinates.
         final int x_vp = x - 1;
         final int y_vp = h - (int)Math.round(y);

         if (x_vp >= 0 && x_vp < w && y_vp >= 0 && y_vp < h) // Clipping test.
         {
            vp.setPixelVP(x_vp, y_vp, c);
         }
      }// Advance (x,y) to the next pixel. Since delta_x = 1, we need delta_y = m.
   }
}
